VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Begin VB.Form frmWinMixer 
   BorderStyle     =   4  'Festes Werkzeugfenster
   Caption         =   "Windows Mixer - playback volume settings"
   ClientHeight    =   1560
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   6195
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   104
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   413
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'Fenstermitte
   Begin ComctlLib.Slider sldMainVol 
      Height          =   345
      Left            =   1500
      TabIndex        =   7
      Top             =   675
      Width           =   3690
      _ExtentX        =   6509
      _ExtentY        =   609
      _Version        =   327682
      Max             =   65535
      TickStyle       =   3
   End
   Begin prjMonoton.ccXPButton cmdShellMixer 
      Height          =   315
      Left            =   5250
      TabIndex        =   6
      Top             =   120
      Width           =   840
      _ExtentX        =   1482
      _ExtentY        =   556
      Caption         =   "Mixer"
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.CheckBox chkMuteMain 
      Caption         =   "Mute"
      Height          =   240
      Left            =   5325
      TabIndex        =   5
      Top             =   720
      Width           =   765
   End
   Begin VB.CheckBox chkMute 
      Caption         =   "Mute"
      Height          =   240
      Index           =   0
      Left            =   5325
      TabIndex        =   4
      Top             =   1125
      Width           =   765
   End
   Begin VB.ComboBox cboDev 
      Height          =   315
      Left            =   1575
      Style           =   2  'Dropdown-Liste
      TabIndex        =   1
      Top             =   120
      Width           =   3540
   End
   Begin ComctlLib.Slider sldVolSource 
      Height          =   345
      Index           =   0
      Left            =   1500
      TabIndex        =   8
      Top             =   1125
      Width           =   3690
      _ExtentX        =   6509
      _ExtentY        =   609
      _Version        =   327682
      Max             =   65535
      TickStyle       =   3
   End
   Begin VB.Label lblSource 
      Alignment       =   1  'Rechts
      AutoSize        =   -1  'True
      Caption         =   "Source"
      Height          =   195
      Index           =   0
      Left            =   900
      TabIndex        =   3
      Top             =   1140
      Width           =   495
   End
   Begin VB.Label lblMainVol 
      Alignment       =   1  'Rechts
      AutoSize        =   -1  'True
      Caption         =   "Main volume:"
      Height          =   195
      Left            =   450
      TabIndex        =   2
      Top             =   720
      Width           =   945
   End
   Begin VB.Label lblDev 
      AutoSize        =   -1  'True
      Caption         =   "Device:"
      Height          =   195
      Left            =   855
      TabIndex        =   0
      Top             =   165
      Width           =   540
   End
End
Attribute VB_Name = "frmWinMixer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function waveOutGetNumDevs Lib "winmm.dll" ( _
) As Long

Private Declare Function waveOutGetDevCaps Lib "winmm.dll" _
Alias "waveOutGetDevCapsA" ( _
    ByVal uDeviceID As Long, _
    lpCaps As WAVEOUTCAPS, _
    ByVal uSize As Long _
) As Long

Private Type WAVEOUTCAPS
    wMid            As Integer
    wPid            As Integer
    vDriverVersion  As Long
    szPname         As String * 32
    dwFormats       As Long
    wChannels       As Integer
    dwSupport       As Long
End Type

Private lngDev      As Long
Private lngDst      As Long

Private Sub cboDev_Click()
    Dim i           As Long
    Dim j           As Long
    Dim lngSrcs     As Long
    Dim lngDsts     As Long
    Dim lngTop      As Long

    lngDev = cboDev.ListIndex

    lngDsts = MixerDestinations(lngDev)

    For i = 0 To lngDsts - 1
        If MixerDestinationType(lngDev, i) = MIXERLINE_COMPONENTTYPE_DST_SPEAKERS Then
            lngSrcs = MixerDestinationConnections(lngDev, i)
            Exit For
        End If
    Next

    If i >= lngDsts Then
        lngDst = 0
    Else
        lngDst = i
    End If

    For i = lblSource.UBound To 1 Step -1
        lblSource(i).Visible = False
        sldVolSource(i).Visible = False
    Next

    lngTop = lblSource(0).Top

    For i = 0 To lngSrcs - 1
        If i > lblSource.UBound Then Load lblSource(i)
        With lblSource(i)
            .Top = lngTop
            .Caption = TrimEx(MixerConnectionName(lngDev, lngDst, i)) & ":"
            .Visible = True
        End With

        If i > sldVolSource.UBound Then Load sldVolSource(i)
        With sldVolSource(i)
            .Top = lblSource(i).Top
            .Visible = True
        End With

        If i > chkMute.UBound Then Load chkMute(i)
        With chkMute(i)
            .Top = lblSource(i).Top + 2
            .Visible = True
        End With

        lngTop = lngTop + lblSource(i).Height + 10
    Next

    lngTop = lngTop + lblSource(i - 1).Height + 20

    With lblSource(i - 1)
        Me.Height = lngTop * Screen.TwipsPerPixelY
    End With

    UpdateVolume lngDst, lngSrcs
End Sub

Private Sub UpdateVolume( _
    ByVal lngDst As Long, _
    ByVal lngSrcs As Long _
)

    Dim i       As Long
    Dim udtVol  As volume_stereo

    udtVol = MixerDestinationVolume(lngDev, lngDst)

    sldMainVol.Value = udtVol.L
    chkMuteMain.Value = Abs(MixerDestinationMute(lngDev, lngDst))

    For i = 0 To lngSrcs - 1
        sldVolSource(i).Value = MixerConnectionVolume(lngDev, lngDst, i).L
        chkMute(i).Value = Abs(MixerConnectionMute(lngDev, lngDst, i))
    Next
End Sub

Private Sub chkMute_Click( _
    Index As Integer _
)

    MixerSetConnectionMute lngDev, lngDst, Index, chkMute(Index).Value
End Sub

Private Sub chkMuteMain_Click()
    MixerSetDestinationMute lngDev, lngDst, chkMuteMain.Value
End Sub

Private Sub cmdShellMixer_Click()
    On Error GoTo ErrorHandler

    Shell "sndvol32.exe", vbNormalFocus
    Exit Sub

ErrorHandler:
    MsgBox "Could not open sndvol32.exe" & vbCrLf & _
           "Error " & Err.number & " (" & Err.Description & ")", _
           vbExclamation, APPNAME
End Sub

Private Sub Form_Load()
    Dim i           As Long
    Dim lngDevs     As Long
    Dim udtDev      As WAVEOUTCAPS

    lngDevs = waveOutGetNumDevs()
    If lngDevs = 0 Then
        MsgBox "Could not find any output devices!", vbExclamation, APPNAME
        Exit Sub
    End If

    cboDev.Clear

    For i = 0 To lngDevs - 1
        waveOutGetDevCaps i, udtDev, Len(udtDev)
        cboDev.AddItem udtDev.szPname
    Next

    cboDev.ListIndex = 0
End Sub

Private Sub sldMainVol_Click()
    sldMainVol_Scroll
End Sub

Private Sub sldMainVol_Scroll()
    Dim udtVol      As volume_stereo
    Dim sngRatio    As Single

    udtVol = MixerDestinationVolume(lngDev, lngDst)

    If udtVol.r = 0 Or udtVol.L = 0 Then
        sngRatio = 1
    Else
        sngRatio = udtVol.L / udtVol.r
    End If

    If sngRatio <= 1 Then
        udtVol.L = sldMainVol.Value * sngRatio
        udtVol.r = sldMainVol.Value
    Else
        udtVol.L = sldMainVol.Value
        udtVol.r = sldMainVol.Value / sngRatio
    End If

    If MixerDestinationChannels(lngDev, lngDst) = 1 Then
        udtVol.r = 0
    End If

    MixerSetDestinationVolume lngDev, lngDst, udtVol
End Sub

Private Sub sldVolSource_Click( _
    Index As Integer _
)

    sldVolSource_Scroll Index
End Sub

Private Sub sldVolSource_Scroll( _
    Index As Integer _
)

    Dim udtVol      As volume_stereo
    Dim sngRatio    As Single

    udtVol = MixerConnectionVolume(lngDev, lngDst, Index)

    If udtVol.r = 0 Or udtVol.L = 0 Then
        sngRatio = 1
    Else
        sngRatio = udtVol.L / udtVol.r
    End If

    If sngRatio <= 1 Then
        udtVol.L = sldVolSource(Index).Value * sngRatio
        udtVol.r = sldVolSource(Index).Value
    Else
        udtVol.L = sldVolSource(Index).Value
        udtVol.r = sldVolSource(Index).Value / sngRatio
    End If

    If MixerConnectionChannels(lngDev, lngDst, Index) = 1 Then
        udtVol.r = 0
    End If

    MixerSetConnectionVolume lngDev, lngDst, Index, udtVol
End Sub
