Attribute VB_Name = "Funzioni_form_editor"
'-----------------------------COSTANTI PER TIMELINE--------------------------------
Global Const Editor_Timeline_ColPos As Integer = 0
Global Const Editor_Timeline_ColStringa As Integer = 1
Global Const Editor_Timeline_LarghezzaPos As Integer = 500
Global Const Editor_Timeline_LarghezzaStringa As Integer = 1600
'---------------------------------TIPI DI STEP PER LA TIMELINE----------------------------------
Global Const Editor_Timeline_StepVuoto As String = "vuoto"
Global Const Editor_Timeline_StepPieno As String = "pieno"
Global Const Editor_Timeline_StepRandom As String = "random"
Global Const Editor_Timeline_StepCarattere As String = "carattere"

'----------------------------------COSTANTI PER TABELLE EDITOR TIMELINE-------------------------------------
Global Const Editor_Tabella_LarghezzaQuadrato As Integer = 450
Global Const Editor_Tabella_ColoreAcceso As Long = 16711680 'blu scuro
Global Const Editor_Tabella_ColoreSpento As Long = 0 'bianco (16777215)
Global Const Editor_Tabella_ColoreDisabilitato As Long = 1 'nero

Public Function InizializzaTabelleEditor() 'inizializza le tabelle all'apertura del form
    Dim IndiceTabella As Integer
    
    For IndiceTabella = 1 To 8 'scorro tutte le tabelle
        With FormEditor.Tabella(IndiceTabella)
            'rendo visibile la PRIMA tabella
            If IndiceTabella = 1 Then
                .Visible = True
                FormEditor.lblLivelloVisualizzato.Caption = "Livello visualizzato: " & IndiceTabella
            Else
                .Visible = False
            End If
            'imposto la larghezza delle righe e delle colonne di tutte le tabelle
            For i = 0 To 9
                .ColWidth(i) = Editor_Tabella_LarghezzaQuadrato
                .RowHeight(i) = Editor_Tabella_LarghezzaQuadrato
            Next i
            'imposto la propriet fillstyle per colorare tutte le celle selezionate
            .FillStyle = flexFillRepeat
            
        End With
        'contrassegno le celle disabilitate
        Call ColoraCellaEditor(IndiceTabella, 0, 0, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 0, 1, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 0, 2, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 0, 3, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 0, 6, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 0, 7, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 0, 8, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 0, 9, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 1, 0, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 1, 9, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 2, 0, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 2, 9, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 3, 0, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 3, 9, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 6, 0, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 6, 9, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 7, 0, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 7, 9, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 8, 0, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 8, 9, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 9, 0, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 9, 1, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 9, 2, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 9, 3, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 9, 6, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 9, 7, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 9, 8, Editor_Tabella_ColoreDisabilitato)
        Call ColoraCellaEditor(IndiceTabella, 9, 9, Editor_Tabella_ColoreDisabilitato)
    Next IndiceTabella
End Function

Public Function ColoraCellaEditor(IndiceTabella As Integer, Riga As Integer, Colonna As Integer, Colore As Long)
'mette il colore DISABILITATO ad una determinata cella della tabella specificata
    With FormEditor.Tabella(IndiceTabella)
        .Row = Riga 'seleziono la riga della cella da colorare
        .Col = Colonna 'seleziono la colonna della cella da colorare
        .CellBackColor = Colore 'coloro la cella
    End With
End Function

Public Function LeggiCellaTabellaEditor(IndiceTabella As Integer, Riga As Integer, Colonna As Integer) As Integer
'legge una determinata cella della tabella specificata e ritorna 1 se  colorata oppure 0 se  bianca
    With FormEditor.Tabella(IndiceTabella)
        .Row = Riga 'seleziono la riga della cella da controllare
        .Col = Colonna 'seleziono la colonna della cella da controllare
        
        If .CellBackColor <> Editor_Tabella_ColoreSpento Then 'se la cella selezionata  colorata
            LeggiCellaTabellaEditor = 1
        Else 'se la cella  bianca
            LeggiCellaTabellaEditor = 0
        End If
    End With
End Function

Public Function ColoraCellaTabellaEditor(IndiceTabella As Integer) 'colora la cella della tabella visualizzata
    With FormEditor.Tabella(IndiceTabella)
        If .CellBackColor <> Editor_Tabella_ColoreDisabilitato Then 'se la cella non  disabilitata
            If .CellBackColor = Editor_Tabella_ColoreSpento Then 'se la cella  bianca
                .CellBackColor = Editor_Tabella_ColoreAcceso 'colora la cella di blu
            Else 'se la cella  blu
                .CellBackColor = Editor_Tabella_ColoreSpento 'colora la cella di bianco
            End If
        End If
    End With
End Function

Public Function InizializzaTimelineEditor() 'inizializza la timeline all'apertura del form
    With FormEditor.Timeline
        'imposto il numero di righe e delle colonne
        .Rows = 1
        .Cols = 2
        
        'scrivo le intestazioni delle colonne
        .Row = 0 'seleziono la prima riga
        .Col = Editor_Timeline_ColPos 'seleziono la colonna POS
        .Text = "Pos"
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna STRINGA
        .Text = "Stringa"
        
        'imposto la larghezza delle colonne
        .ColWidth(Editor_Timeline_ColPos) = Editor_Timeline_LarghezzaPos
        .ColWidth(Editor_Timeline_ColStringa) = Editor_Timeline_LarghezzaStringa
    End With
End Function

Public Function AggiungiStepTimelineEditor(Posizione As Integer, Tipo As String) 'aggiunge uno step alla fine della timeline
    Dim StringaDaCopiare As String
    
    With FormEditor.Timeline
        .Rows = .Rows + 1 'aggiungo una riga alla timeline
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        If Posizione < .Rows - 1 Then 'se la riga non v aggiunta alla fine
            'scalo gli elementi della timeline fino allo spazio dove v inserito il nuovo elemento
            For i = .Rows - 1 To Posizione + 1 Step -1
                .Row = i - 1
                StringaDaCopiare = .Text
                .Row = i
                .Text = StringaDaCopiare
            Next i
        End If
        
        'inserisco la stringa alla posizione specificata
        .Row = Posizione
        .Text = CreaStepTimelineEditor(Tipo)
        
        Call StringToTabellaEditor(.Text) 'riporto il contenuto della stringa sulla tabella
        Call RiempiPosTimelineEditor 'riempo la colonna delle posizioni
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        .Row = Posizione
    End With
End Function

Public Function AggiornaStepTimelineEditor() 'aggiorna la stringa della posizione corrente
    With FormEditor.Timeline
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        .Text = TabellaToStringEditor 'riporto lo stato attuale della tabella
    End With
End Function

Public Function CreaStepTimelineEditor(Tipo As String) As String
    Dim Stringa As String
    Dim LunghezzaStringa As Integer
    
    Stringa = ""
    LunghezzaStringa = 512 + (8 * 8) '512 led + 8 led laterali per ogni livello
    Select Case Tipo
        Case Editor_Timeline_StepVuoto:
            For i = 1 To LunghezzaStringa
                Stringa = Stringa & "0"
            Next i
        Case Editor_Timeline_StepPieno:
            For i = 1 To LunghezzaStringa
                Stringa = Stringa & "1"
            Next i
        Case Editor_Timeline_StepRandom:
            For i = 1 To LunghezzaStringa
                Stringa = Stringa & RandomNumbers(0, 1, 0)
            Next i
        Case Editor_Timeline_StepCarattere:
            'DA FARE
    End Select
    CreaStepTimelineEditor = Stringa 'ritorno la stringa creata
End Function

Public Function RiempiPosTimelineEditor() 'riempie la colonna POS della timeline
    With FormEditor.Timeline
        For i = 1 To .Rows - 1
            .Col = Editor_Timeline_ColPos 'seleziono la colonna POS
            .Row = i
            .Text = i
        Next i
    End With
End Function

Public Function TabellaToStringEditor() As String 'riporta lo stato attuale della tabella su una stringa
'COMPOSIZIONE STRINGA: 512 caratteri per led normali + 8*8 caratteri per led laterali
    Dim ContaTabelle As Integer
    Dim ContaRighe As Integer
    Dim ContaColonne As Integer
    Dim StringaTabella As String
    
    StringaTabella = "" 'azzero la stringa
    
    For ContaTabelle = 1 To 8 'scorro i livelli segnandomi lo stato dei led normali
        For ContaRighe = 1 To 8 'scorro le righe
            For ContaColonne = 1 To 8 'scorro le colonne
                StringaTabella = StringaTabella & LeggiCellaTabellaEditor(ContaTabelle, ContaRighe, ContaColonne)
            Next ContaColonne
        Next ContaRighe
    Next ContaTabelle
    
    For ContaTabelle = 1 To 8 'scorro i livelli segnandomi lo stato dei led laterali
        StringaTabella = StringaTabella & LeggiCellaTabellaEditor(ContaTabelle, 0, 4)
        StringaTabella = StringaTabella & LeggiCellaTabellaEditor(ContaTabelle, 0, 5)
        StringaTabella = StringaTabella & LeggiCellaTabellaEditor(ContaTabelle, 4, 9)
        StringaTabella = StringaTabella & LeggiCellaTabellaEditor(ContaTabelle, 5, 9)
        StringaTabella = StringaTabella & LeggiCellaTabellaEditor(ContaTabelle, 9, 5)
        StringaTabella = StringaTabella & LeggiCellaTabellaEditor(ContaTabelle, 9, 4)
        StringaTabella = StringaTabella & LeggiCellaTabellaEditor(ContaTabelle, 5, 0)
        StringaTabella = StringaTabella & LeggiCellaTabellaEditor(ContaTabelle, 4, 0)
    Next ContaTabelle
    
    TabellaToStringEditor = StringaTabella
End Function

Public Function StringToTabellaEditor(Stringa As String) 'riporta la stringa passata alla funzione sulla tabella
    Dim ContaTabelle As Integer
    Dim ContaRighe As Integer
    Dim ContaColonne As Integer
    Dim ContaLedLaterali As Integer
    Dim Posizione As Integer
    
    For ContaTabelle = 1 To 8
        For ContaRighe = 1 To 8
            For ContaColonne = 1 To 8
                Posizione = ((ContaTabelle - 1) * 64) + ((ContaRighe - 1) * 8) + ContaColonne
                If Mid(Stringa, Posizione, 1) = 1 Then
                    Call ColoraCellaEditor(ContaTabelle, ContaRighe, ContaColonne, Editor_Tabella_ColoreAcceso)
                Else
                    Call ColoraCellaEditor(ContaTabelle, ContaRighe, ContaColonne, Editor_Tabella_ColoreSpento)
                End If
            Next ContaColonne
        Next ContaRighe
    Next ContaTabelle
    
    For ContaTabelle = 1 To 8
        Posizione = 512 + ((ContaTabelle - 1) * 8)
        
        If Mid(Stringa, Posizione + 1, 1) = 1 Then 'LATERALE 1
            Call ColoraCellaEditor(ContaTabelle, 0, 4, Editor_Tabella_ColoreAcceso)
        Else
            Call ColoraCellaEditor(ContaTabelle, 0, 4, Editor_Tabella_ColoreSpento)
        End If
        If Mid(Stringa, Posizione + 2, 1) = 1 Then 'LATERALE 2
            Call ColoraCellaEditor(ContaTabelle, 0, 5, Editor_Tabella_ColoreAcceso)
        Else
            Call ColoraCellaEditor(ContaTabelle, 0, 5, Editor_Tabella_ColoreSpento)
        End If
        If Mid(Stringa, Posizione + 3, 1) = 1 Then 'LATERALE 3
            Call ColoraCellaEditor(ContaTabelle, 4, 9, Editor_Tabella_ColoreAcceso)
        Else
            Call ColoraCellaEditor(ContaTabelle, 4, 9, Editor_Tabella_ColoreSpento)
        End If
        If Mid(Stringa, Posizione + 4, 1) = 1 Then 'LATERALE 4
            Call ColoraCellaEditor(ContaTabelle, 5, 9, Editor_Tabella_ColoreAcceso)
        Else
            Call ColoraCellaEditor(ContaTabelle, 5, 9, Editor_Tabella_ColoreSpento)
        End If
        If Mid(Stringa, Posizione + 5, 1) = 1 Then 'LATERALE 5
            Call ColoraCellaEditor(ContaTabelle, 9, 5, Editor_Tabella_ColoreAcceso)
        Else
            Call ColoraCellaEditor(ContaTabelle, 9, 5, Editor_Tabella_ColoreSpento)
        End If
        If Mid(Stringa, Posizione + 6, 1) = 1 Then 'LATERALE 6
            Call ColoraCellaEditor(ContaTabelle, 9, 4, Editor_Tabella_ColoreAcceso)
        Else
            Call ColoraCellaEditor(ContaTabelle, 9, 4, Editor_Tabella_ColoreSpento)
        End If
        If Mid(Stringa, Posizione + 7, 1) = 1 Then 'LATERALE 7
            Call ColoraCellaEditor(ContaTabelle, 5, 0, Editor_Tabella_ColoreAcceso)
        Else
            Call ColoraCellaEditor(ContaTabelle, 5, 0, Editor_Tabella_ColoreSpento)
        End If
        If Mid(Stringa, Posizione + 8, 1) = 1 Then 'LATERALE 8
            Call ColoraCellaEditor(ContaTabelle, 4, 0, Editor_Tabella_ColoreAcceso)
        Else
            Call ColoraCellaEditor(ContaTabelle, 4, 0, Editor_Tabella_ColoreSpento)
        End If
    Next ContaTabelle
End Function

Public Function ResetTimelineEditor()
    Call InizializzaTimelineEditor 'inizializza la timeline sul form EDITOR
    Call AggiungiStepTimelineEditor(1, Editor_Timeline_StepVuoto) 'aggiunge uno step vuoto alla timeline
End Function

Public Function SalvaTimelineEditor()
On Error GoTo fine
    Dim PercorsoSave As String: PercorsoSave = App.Path & "\" & PathAnimazioni 'path salvataggio
    Dim NomeFile As String
    Dim ContaRighe As Integer
    
    FormEditor.CommonDialogEditor.InitDir = PercorsoSave 'directory iniziale
    FormEditor.CommonDialogEditor.DialogTitle = "SALVATAGGIO TIMELINE" 'titolo finestra
    FormEditor.CommonDialogEditor.Filter = "File di testo (*.txt)|*.txt" 'filtro file txt
    FormEditor.CommonDialogEditor.ShowSave 'visualizza la finestra
    
    NomeFile = FormEditor.CommonDialogEditor.FileName 'segna il nome selezionato (comprensivo di path ed estensione)
    
    If NomeFile <> "" Then 'se l'utente ha inserito il nome
    
        Open NomeFile For Output As #1 'apro il file in scrittura
        
        With FormEditor.Timeline
            .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
            For ContaRighe = 1 To .Rows - 1 'scorro tutte le righe
                .Row = ContaRighe 'seleziono la riga corrente
                Print #1, .Text 'scrivo una riga sul file
            Next ContaRighe
        End With

        Close #1 'chiudo il file
        
        Call MsgBox("Salvataggio completato!")
    Else
        Call MsgBox("Salvataggio annullato!")
    End If
Exit Function
fine:
    Close #1
    MsgBox Err.Description
End Function

Public Function CaricaTimelineEditor()
On Error GoTo fine
    Dim PercorsoOpen As String: PercorsoOpen = App.Path & "\" & PathAnimazioni 'path predefinita
    Dim NomeFile As String
    Dim StringaLetta As String
    
    FormEditor.CommonDialogEditor.InitDir = PercorsoOpen 'directory iniziale
    FormEditor.CommonDialogEditor.DialogTitle = "CARICAMENTO TIMELINE" 'titolo finestra
    FormEditor.CommonDialogEditor.Filter = "File di testo (*.txt)|*.txt" 'filtro file txt
    FormEditor.CommonDialogEditor.ShowOpen 'visualizza la finestra
    
    NomeFile = FormEditor.CommonDialogEditor.FileName 'segna il nome selezionato (comprensivo di path ed estensione)
    
    If NomeFile <> "" Then 'se l'utente ha scelto il file
        Call InizializzaTimelineEditor 'resetto la timeline (completamente vuota)
        
        Open NomeFile For Input As 1 'apro il file scelto dall'utente
        With FormEditor.Timeline
            .Col = Editor_Timeline_ColStringa
            Do
                .Rows = .Rows + 1
                .Row = .Rows - 1
                Input #1, StringaLetta
                .Text = StringaLetta
            Loop Until EOF(1) = True 'loop fino alla fine del file
        End With
        
        Close #1
        
        Call RiempiPosTimelineEditor 'riempo la colonna delle posizioni
        
        Call MsgBox("Caricamento completato!")
    Else
        Call MsgBox("Caricamento annullato!")
    End If
Exit Function
fine:
    Close #1
    MsgBox Err.Description
End Function

Public Function CancellaStepTimelineEditor(IndiceElementoDaCancellare As Integer)
    Dim StringaDaSpostare As String
    Dim Risposta As Variant
    
    'chiedo all'utente se  sicuro oppure vuole cancellare l'azione
    Risposta = MsgBox("L'elemento corrente della timeline sar cancellato. Sei sicuro?", vbYesNo, "CANCELLAZIONE ELEMENTO TIMELINE")
    
    If Risposta = vbYes Then
        With FormEditor.Timeline
            If IndiceElementoDaCancellare = .Rows - 1 Then 'se l'elemento da cancellare  l'ultimo
                .Rows = .Rows - 1
            ElseIf IndiceElementoDaCancellare > 0 And IndiceElementoDaCancellare < .Rows - 1 Then 'se l'elemento da cancellare  compreso tra la prima riga e la penultima
                'scalo tutte le righe di un elemento sopra
                .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle strighe
                For i = IndiceElementoDaCancellare To .Rows - 2
                    .Row = i + 1 'seleziono la riga successiva a quella da cancellare
                    StringaDaSpostare = .Text 'copio l'elemento successivo a quello da spostare
                    .Row = i 'seleziono la riga da cancellare
                    .Text = StringaDaSpostare 'sovrascrivo il contenuto
                Next i
                'cancello l'ultima riga
                .Rows = .Rows - 1
            End If
            
            If .Rows = 1 Then Call AggiungiStepTimelineEditor(1, Editor_Timeline_StepVuoto) 'se  rimasta solo l'intestazione aggiunge uno step vuoto alla timeline
            Call StringToTabellaEditor(.Text) 'riporto il contenuto della stringa sulla tabella
            Call RiempiPosTimelineEditor 'riempo la colonna delle posizioni
            .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
            .Row = IndiceElementoDaCancellare
        End With
    End If
End Function

Public Function SpostaStepSu(IndiceElementoDaSpostare)
    Dim StringaDaSpostare As String
    Dim StringaAppoggio As String
    
    With FormEditor.Timeline
        If IndiceElementoDaSpostare > 1 Then 'se sono almeno alla seconda posizione (pi su della prima non posso andare!!!)
            .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle strighe
            .Row = IndiceElementoDaSpostare 'mi posiziono alla riga dell'elemento da spostare
            StringaDaSpostare = .Text 'segno la stringa da spostare
            .Row = IndiceElementoDaSpostare - 1 'mi posiziono alla riga da sovrascrivere
            StringaAppoggio = .Text 'segno da una parte la stringa della riga che verr sovrascritta
            .Text = StringaDaSpostare 'sovrascrivo alla posizione dove mi devo spostare
            .Row = IndiceElementoDaSpostare 'ritorno alla posizione originale
            .Text = StringaAppoggio 'scrivo la stringa dove sono andato a sovrascrivere
            .Row = IndiceElementoDaSpostare - 1 'seleziono la nuova posizione della stringa
        End If
    End With
End Function

Public Function SpostaStepGiu(IndiceElementoDaSpostare)
    Dim StringaDaSpostare As String
    Dim StringaAppoggio As String
    
    With FormEditor.Timeline
        If IndiceElementoDaSpostare < .Rows - 1 Then 'se sono almeno alla penultima posizione (pi giu dell'ultima non posso andare!!!)
            .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle strighe
            .Row = IndiceElementoDaSpostare 'mi posiziono alla riga dell'elemento da spostare
            StringaDaSpostare = .Text 'segno la stringa da spostare
            .Row = IndiceElementoDaSpostare + 1 'mi posiziono alla riga da sovrascrivere
            StringaAppoggio = .Text 'segno da una parte la stringa della riga che verr sovrascritta
            .Text = StringaDaSpostare 'sovrascrivo alla posizione dove mi devo spostare
            .Row = IndiceElementoDaSpostare 'ritorno alla posizione originale
            .Text = StringaAppoggio 'scrivo la stringa dove sono andato a sovrascrivere
            .Row = IndiceElementoDaSpostare + 1 'seleziono la nuova posizione della stringa
        End If
    End With
End Function

Public Function DuplicaElemento(Posizione As Integer) 'duplica l'elemento corrente
    Dim StringaDaCopiare As String
    
    With FormEditor.Timeline
        .Rows = .Rows + 1 'aggiungo una riga alla timeline
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        
        'scalo gli elementi della timeline fino allo spazio dove v inserito il nuovo elemento
        For i = .Rows - 1 To Posizione + 1 Step -1
            .Row = i - 1
            StringaDaCopiare = .Text
            .Row = i
            .Text = StringaDaCopiare
        Next i
        
        Call StringToTabellaEditor(.Text) 'riporto il contenuto della stringa sulla tabella
        Call RiempiPosTimelineEditor 'riempo la colonna delle posizioni
        
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        .Row = Posizione + 1
    End With
End Function
